import getNodeScroll from './getNodeScroll';
import getOffsetParent from './getOffsetParent';

var sumScroll = function sumScroll(scrollParents) {
  return scrollParents.reduce(function (scroll, scrollParent) {
    var nodeScroll = getNodeScroll(scrollParent);
    scroll.scrollTop += nodeScroll.scrollTop;
    scroll.scrollLeft += nodeScroll.scrollLeft;
    return scroll;
  }, {
    scrollTop: 0,
    scrollLeft: 0
  });
};

export default function getCommonTotalScroll(reference, referenceScrollParents, popperScrollParents, limiter) {
  // if the scrollParent is shared between the two elements, we don't pick
  // it because it wouldn't add anything to the equation (they nulllify themselves)
  var nonCommonReference = referenceScrollParents.filter(function (node) {
    return !popperScrollParents.includes(node);
  }); // we then want to pick any scroll offset except for the one of the offsetParent
  // not sure why but that's how I got it working 😅
  // TODO: improve this comment with proper explanation

  var offsetParent = getOffsetParent(reference);
  var index = referenceScrollParents.findIndex(function (node) {
    return node === (limiter || offsetParent);
  });
  var scrollParents = referenceScrollParents.slice(0, index === -1 ? undefined : index);
  return sumScroll(scrollParents);
}