import getElementMargins from './getElementMargins'; // Returns the width, height and offsets of the provided element

export default (function (element) {
  // get the basic client rect, it doesn't include margins
  var width = element.offsetWidth;
  var height = element.offsetHeight;
  var top = element.offsetTop;
  var left = element.offsetLeft;
  var margins = getElementMargins(element);
  return {
    width: width + margins.left + margins.right,
    height: height + margins.top + margins.bottom,
    y: top - margins.top,
    x: left - margins.left
  };
});