function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// This modifier takes the styles prepared by the `computeStyles` modifier
// and applies them to the HTMLElements such as popper and arrow
export function applyStyles(state) {
  Object.keys(state.elements).forEach(function (name) {
    var style = state.styles.hasOwnProperty(name) ? state.styles[name] : {}; // Flow doesn't support to extend this property, but it's the most
    // effective way to apply styles to an HTMLElement
    // $FlowIgnore

    Object.assign(state.elements[name].style, style);
  });
  return state;
}
export function onDestroy(state) {
  Object.keys(state.elements).forEach(function (name) {
    var styleProperties = Object.keys(state.styles.hasOwnProperty(name) ? _extends({}, state.styles[name]) : {}); // Set all values to an empty string to unset them

    var style = styleProperties.reduce(function (style, property) {
      var _extends2;

      return _extends({}, style, (_extends2 = {}, _extends2[String(property)] = '', _extends2));
    }, {}); // Flow doesn't support to extend this property, but it's the most
    // effective way to apply styles to an HTMLElement
    // $FlowIgnore

    Object.assign(state.elements[name].style, style);
  });
}
export default {
  name: 'applyStyles',
  enabled: true,
  phase: 'write',
  fn: applyStyles,
  onDestroy: onDestroy,
  requires: ['computeStyles']
};