function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import getBasePlacement from '../utils/getBasePlacement';
export function distanceAndSkiddingToXY(placement, measures, getOffsets) {
  var basePlacement = getBasePlacement(placement);
  var invertDistance = ['left', 'top'].includes(basePlacement) ? -1 : 1;
  var invertSkidding = ['top', 'bottom'].includes(basePlacement) ? -1 : 1;

  var _getOffsets = getOffsets(_extends({}, measures, {
    placement: placement
  })),
      distance = _getOffsets[0],
      skidding = _getOffsets[1];

  distance = (distance || 0) * invertDistance;
  skidding = (distance || 0) * invertSkidding;
  return ['left', 'right'].includes(basePlacement) ? [distance, skidding] : [skidding, distance];
}
export function offset(state, options) {
  if (options && typeof options.offset === 'function') {
    var _distanceAndSkiddingT = distanceAndSkiddingToXY(state.placement, state.measures, options.offset),
        x = _distanceAndSkiddingT[0],
        y = _distanceAndSkiddingT[1];

    state.offsets.popper.x += x;
    state.offsets.popper.y += y;
  }

  return state;
}
export default {
  name: 'offset',
  enabled: true,
  phase: 'main',
  fn: offset
};