export default function microtaskDebounce(fn) {
  var called = false;
  return function () {
    return new Promise(function (resolve) {
      if (called) {
        return resolve();
      }

      called = true;
      Promise.resolve().then(function () {
        called = false;
        resolve(fn());
      });
    });
  };
}